<!DOCTYPE html>
<html lang="en">
	<head>
		<meta charset="UTF-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=edge" />
		<meta name="viewport" content="width=device-width, initial-scale=1.0" />
		<title>Listing</title>
		<script src="https://cdn.jsdelivr.net/npm/handsontable/dist/handsontable.full.min.js"></script>
		<script src="https://cdn.jsdelivr.net/npm/moment@2.29.4/moment.min.js"></script>
		<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/handsontable/dist/handsontable.full.min.css" />
	</head>
	<body>
		<div id="example1"></div>
		<script type="text/javascript">
			const container = document.getElementById('example1');
			const data = [];
			const isInteger = (datum) => datum === parseInt(datum, 10)

			const createLinkNode = (value, link) => {
				let href = document.createElement('a');
				href.textContent = value;
				href.href = link
				href.target = "_blank"
				return href;
			}

			const linkRenderer = (instance, td, row, col, prop, value, cellProperties) => {
				td.innerHTML = '';
				td.appendChild(createLinkNode(value, `https://alt.fit.cvut.cz/shortener/get/${value}?nostats`))
			}

			const linkRendererImport = (instance, td, row, col, prop, value, cellProperties) => {
				td.innerHTML = '';
				td.appendChild(createLinkNode(value, `https://alt.fit.cvut.cz/webui-staging/?s=${value}&nostats`))
			}

			Handsontable.renderers.registerRenderer('linkRenderer', linkRenderer);
			Handsontable.renderers.registerRenderer('linkRendererImport', linkRendererImport);

			const hot = new Handsontable(container, {
				data,
				height: 'auto',
				width: 'auto',
				stretchH: 'all',
				colHeaders: ['key', 'ALT', 'db_key', 'created', 'accessed', 'hits'],
				columns: [
					{ data: 'key', readOnly: true, renderer: 'linkRenderer' },
					{ data: 'key', readOnly: true, renderer: 'linkRendererImport' },
					{ data: 'db_key', readOnly: true, },
					{ data: 'dt_created', type: 'time', readOnly: true, },
					{ data: 'dt_last_accessed', type: 'time', readOnly: true, },
					{ data: 'hits', readOnly: true, },
				],
				columnSorting: {
					sortEmptyCells: true,
					indicator: true,
					headerAction: true,
					compareFunctionFactory: function(sortOrder, columnMeta) {
						return function(a, b) {
							if (!a) {
								return -1;
							} else if (isInteger(a)) {
								return parseInt(a, 10) - parseInt(b, 10)
							} else {
								return a.localeCompare(b);
							}
						}
					}
				},
				multiColumnSorting: true,
				minSpareRows: 0,
				licenseKey: 'non-commercial-and-evaluation',
			});

			fetch('https://alt.fit.cvut.cz/shortener/list/api')
				.then(resp => resp.json())
				.then(data => hot.loadData(data))

		</script>
	</body>
</html>
